<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_8</title>
</head>
<body>
    <h1>Capitulo 8</h1>
    <a>Ejercicio 2</a>

    <script>   

        const printMatrix = (mat,m,n,i,j,path,idx) => {
            path[idx] = mat[i][j];
          
            if (i == m - 1) {

                for (let k = j + 1; k < n; k++) {
                    path[idx + k - j] = mat[i][k];
                }

                for (let l = 0; l < idx + n - j; l++) {
                    console.log(path[l]);
                }
                console.log("--------------------");
                return;
            }
            
            if (j == n - 1) {

                for (let k = i + 1; k < m; k++) {
                    path[idx + k - i] = mat[k][j];
                }

                for (let l = 0; l < idx + m - i; l++) {
                    console.log(path[l]);
                } return;
            }
            printMatrix(mat, m, n, i + 1, j, path, idx + 1);  
            printMatrix(mat, m, n, i, j + 1, path, idx + 1);
        }
 
        let m = 2,
            n = 3,
          mat = [[ 1, 2, 3 ],[ 4, 5, 6 ]],
        maxLengthOfPath = m + n - 1;
        printMatrix(mat, m, n, 0, 0, new Array(maxLengthOfPath), 0);

        
</script>
    
</body>
</html>